#!/bin/bash
URI="http://127.0.0.1:3020"

out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#################################################","level" : "info" }'`
out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#             REPORTING BUSINESS DAY            #","level" : "info" }'`
out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#################################################","level" : "info" }'`

out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`

echo "###> status: $out"
if [[ "$out" == *"WaitTrEnd"* ]]; then
   echo "###> Reading last transaction details before starting new one"
   out=`curl -s -XGET "$URI/polcard/v1/ingenico_transaction_end?fulldebug=true&resetstate=true" -H 'Content-Type: application/json'`
   echo "###> end: $out"
   exit;
fi

if [[ "$out" == *"Idle"* ]]; then
   echo "###> Starting cutoff"
   out=`curl -s -XPOST "$URI/polcard/v1/ingenico_cutoff_report?fulldebug=true" -H 'Content-Type: application/json' -d '{
      "transport" : {
         "encryptSession" : false
      }
   }'`
   isOK=`echo $out | jq -r '.ok'`
   if [[ "$isOK" == "true" ]]; then
      echo "###> Cutoff started OK"
      echo $out
   else
      echo "###> Error"
      echo $out
      exit;
   fi
else
   echo "Status must be IDLE"
   echo $out
   exit 1
fi

echo "###> Done"
