const config = require('./config');
const effilogger = require('./logger/effilogger');

function not_loggedin(res) {

	return res.status(401).send({
        ok: false,
		message: 'Not logged in'
	});
}

function	error(res, msg /*msg moze byc obiektem albo stringiem*/){

    var logresponseenabled = isLogResponseEnabled();
    const ccdd = {
        ok: false,
        code: (msg.code != null ? msg.code : -1),
        message: (msg.message != null ? msg.message : msg)
    };
    const ccdd_copy = JSON.parse(JSON.stringify(ccdd));
    if (logresponseenabled) logResponse(ccdd_copy);  //logResponse dodaje atrybut "level"
    return res.status(500).json(ccdd);
}

function loginerror(res, msg) {

    return res.status(200).send({
        ok: false,
        message: msg
    });
}

function isLogResponseEnabled() {
    if (config.logger && config.logger.nodejs && config.logger.nodejs.logresponse) return true;
    else return false;
}
function logResponse(obj) {
    effilogger.effilogger.info(obj);
}

function success(res, hits, stats) {

    var logresponseenabled = isLogResponseEnabled();

    if (hits != null)
    {
        if (hits.ok != null) {
            const ccdd_copy = JSON.parse(JSON.stringify(hits));
            if (logresponseenabled) logResponse(ccdd_copy);  //logResponse dodaje atrybut "level"
            return res.json(hits);
        }
        else
        {
            var result = { hits: hits, ok: true };
            if (stats != null)
                result['stats'] = stats;
            const ccdd_copy = JSON.parse(JSON.stringify(result));
            if (logresponseenabled) logResponse(ccdd_copy);//logResponse dodaje atrybut "level"
            return res.json(result);
        }
    }
    else
    {
        var result = { ok: true };
        if (stats != null)
            result['stats'] = stats;
            const ccdd_copy = JSON.parse(JSON.stringify(result));
        if (logresponseenabled) logResponse(ccdd_copy);//logResponse dodaje atrybut "level"
        return res.json(result);
    }
}

module.exports.resp_not_loggedin	= not_loggedin;
module.exports.resp_error           = error;
module.exports.resp_loginerror      = loginerror;
module.exports.resp_success			= success;
